#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct DETE
{
	char *ime,*otac,*majka;
}dete;
struct lista
{
	dete *glava;
	struct lista *rep;
};

dete *dodajdete(FILE*f,int *i)
{
	char naziv[100];
	dete *d;
	d=(dete*)malloc(sizeof(dete));
	fgets(naziv,100,f);
	d->ime=(char*)malloc(strlen(naziv)+1);
	if(strcmp(naziv,"KRAJ\n")==0)
	{
		*i=1;
		return d;
	}
		
	strcpy(d->ime,naziv);
	
	fgets(naziv,100,f);
	d->otac=(char*)malloc(strlen(naziv)+1);
	strcpy(d->otac,naziv);
	
	fgets(naziv,100,f);
	d->majka=(char*)malloc(strlen(naziv)+1);
	strcpy(d->majka,naziv);
	return d;
}

struct lista *dodaj(struct lista *p,FILE *f)
{
	int i=0;
	struct lista *temp,*pom;
	
	
while(1)
{
	temp=(struct lista *)malloc(sizeof(struct lista));
	if(!temp){
		printf("Greska u alokaciji\n");
		exit(0);
	}
	temp->glava=dodajdete(f,&i);
	if(i==0){
		
				temp->rep=NULL;
	if(p==NULL)
	{
		p=temp;
	}
	else
	{
		pom=p;
		while(pom)
		{
			if(pom->rep==NULL)
			{
				pom->rep=temp;
				break;
			}
			else
			pom=pom->rep;
		}
	}
	}
	else
	break;

	
}
		return p;
}

int srodstvo(struct lista *p,char *ime )
{
	dete *d;
	int i=0;
	struct lista *pom;
	pom=p;
	while(pom)
	{
		if(strcmp(ime,pom->glava->ime)==0)
		{
			d=pom->glava;
			break;
		}
		else
		pom=pom->rep;
	}
	while(pom)
	{
		if(strcmp(d->otac,pom->glava->otac)==0 || strcmp(d->majka,pom->glava->majka)==0)
		{
			i++;
			pom=pom->rep;
		}
		else
		pom=pom->rep;
	}
	i--;
	if(i<0) i=0;
	return i;
}

struct lista *brisi(struct lista *p, char *otac, char *majka)
{
	struct lista *pom,*pret;
	pom=p;
	while( p && strcmp(otac,p->glava->otac)==0 && strcmp(majka,p->glava->majka)==0)
	{
		pom=p;
		p=p->rep;
		free(pom);
	}
	pret=p;
	pom=pom->rep;
	while(pom)
	{
		if(strcmp(otac,pom->glava->otac)==0 && strcmp(majka,pom->glava->majka))
		{
			pret->rep=pom->rep;
			free(pom);
			pom=pret->rep;
		}
		else
		{
			pret=pom;
			pom=pom->rep;
		}
	}
	return p;
	
}
	

void ispis(struct lista *p)
{
	while(p)
	{
		printf("%s",p->glava->ime);
		p=p->rep;
	}
}
main(int argc, char *argv[])
{
	dete *d;
	char s[100],otac[100],majka[100];
	int i;
	FILE *f;
	f=fopen(argv[1],"r");
	struct lista *p=NULL;
	p=dodaj(p,f);
	printf("Lista cekanja:\n");
	ispis(p);
	printf("Unesite imena deteta\n");
	scanf("%s",s);
	strcat(s,"\n");
	i=srodstvo(p,s);
	printf("U srodstu je sa %d\n",i);
	printf("unesite ime oca: ");
	scanf("%s",otac);
	strcat(otac,"\n");
	printf("unesite ime majke: ");
	scanf("%s",majka);
	strcat(majka,"\n");
	printf("Lista cekanja nakon brisanja:");

	p=brisi(p, p->glava->otac, p->glava->majka);
	ispis(p);
}
