#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct DETE{
	char *ime_deteta,*ime_oca,*ime_majke;
	};
	
struct lista {
	struct DETE *podaci;
	struct lista *rep;
	};
	
#define novi(x) x=(struct lista *)malloc(sizeof(struct lista))
#define novi_p(x) x=(struct DETE *)malloc(sizeof(struct DETE))
	
struct lista *dodaj_podatke(struct lista *glava,struct DETE *pod){
	struct lista *g;
	
	struct lista *temp;
	novi(temp);
	if(!temp){
		printf("Greska pri alokaciji memorije!\n");
		exit(1);
		}
	temp->podaci=pod;
	temp->rep=NULL;
	
	if(glava==NULL) {
		glava=temp;
		return glava;
	 }
	else{
		g=glava;
		while(g->rep) g=g->rep;
		g->rep=temp;
		return glava;
	}
}
struct lista *formiraj_listu(FILE *f){
	struct lista *glava;
	glava=NULL;
	struct DETE *temp;
	char s[50];
	
	fgets(s,50,f);
	
	while(!feof(f) && strcmp(s,"KRAJ\n")!=0){
		novi_p(temp);
		if(!temp){
			printf("Greska pri alokaciji memorije!\n");
			exit(1);
		}
		//printf("Ucitan");
		
		temp->ime_deteta=(char*)malloc(strlen(s)-1);
		strcpy(temp->ime_deteta,s);
		
		//printf("Ucitan");
		
		fgets(s,50,f);
		temp->ime_oca=(char*)malloc(strlen(s)-1);
		strcpy(temp->ime_oca,s);
		
		//printf("Ucitan");
		
		fgets(s,50,f);
		temp->ime_majke=(char*)malloc(strlen(s)-1);
		strcpy(temp->ime_majke,s);
		
		
		glava=dodaj_podatke(glava,temp);
		
		fgets(s,50,f);
		}
	return glava;
	}
	

void ispis_liste(struct lista *glava){
	struct lista *g;
	g=glava;
	struct DETE *p;
	
	while(g){
		p=g->podaci;
		
		printf("Ime deteta je:\t %s",p->ime_deteta);
		printf("Ime oca je:\t %s",p->ime_oca);
		printf("Ime majke je:\t %s",p->ime_majke);
		
		g=g->rep;
		}
	}
	
	
struct lista *brisi(struct lista *glava,char *otac,char *majka){
	struct lista *prethodni,*trenutni;
	trenutni=glava;
	prethodni=NULL;
	
	while(trenutni){
		if(strcmp(trenutni->podaci->ime_oca,otac)==0 || strcmp(trenutni->podaci->ime_majke,majka)==0){
				if(prethodni==NULL){
					glava=trenutni->rep;
					free(trenutni);
					trenutni=glava;
					}
				else{
					prethodni->rep=trenutni->rep;
					free(trenutni);
					trenutni=prethodni->rep;
					}
				}
		else{
			prethodni=trenutni;
			trenutni=trenutni->rep;
			}
		}
	return glava;
	}	


/*int koliko(struct lista *glava,char *dete){
	
	
	}	*/
	
	
	
	
	
main(int argc,char *argv[]){
	struct lista *glava;
	glava=NULL;
	FILE *f;
	f=fopen(argv[1],"r");
	if(!f){
		printf("Greska pri otvaranju datoteke!'n");
		exit(1);
		}
	glava=formiraj_listu(f);
	printf("Lista cekanja je:\n");
	ispis_liste(glava);
	printf("Unesite imena roditeljskog para: \n");
	char *otac,*majka;
	scanf("%s",otac);
	scanf("%s",majka);
	glava=brisi(glava,otac,majka);
	ispis_liste(glava);
	
	}
	
	
	
	
	
