#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXCH 100

typedef struct {
	char *podnosilac;
	char *zirant1;
	char *zirant2;
	}Podnosilac;
	
struct lista {
	Podnosilac *podnosilac;
	struct lista *sledeci;
	};
	
#define novi(x) x=(struct lista *) malloc(sizeof(struct lista))

char *ispravka(char *s)
{
	int i=0;
	while(s[i]!='\n') i++;
	s[i]='\0';
	return s;
}
void dodaj_k(struct lista **p, Podnosilac *pd)
{
	struct lista *glava,*pom,*el;
	
	novi(el);
	if(!el) {
			printf("Greska pri alociranju memorije.\n");
			exit(0);
			}
	el->podnosilac=pd;
	el->sledeci=NULL;
	glava=*p;
	
	if(!glava) glava=el;
	else{
			pom=glava;
			while(pom->sledeci) pom=pom->sledeci;
			pom->sledeci=el;
		}
	
	*p=glava;
}


Podnosilac* ucitaj(FILE *f)
{
	char s[100];
	Podnosilac *pd;
	pd=(Podnosilac*) malloc(sizeof(Podnosilac));
	if(!pd) {
			printf("Greska pri alociranju memorije.\n");
			exit(0);
			}
		
	fgets(s,MAXCH,f);
	ispravka(s); if((strcmp(s,"KRAJ"))==0) return NULL;
	pd->podnosilac=(char *) malloc(strlen(s)+1);
	strcpy(pd->podnosilac,s);
	
	fgets(s,MAXCH,f);
	ispravka(s);
	pd->zirant1=(char *) malloc(strlen(s)+1);
	strcpy(pd->zirant1,s);
	
	fgets(s,MAXCH,f);
	ispravka(s);
	pd->zirant2=(char *) malloc(strlen(s)+1);
	strcpy(pd->zirant2,s);
	return pd;
}

struct lista *formiraj(FILE *f)
{
	Podnosilac *pd;
	struct lista *p=NULL;
	
	while(!feof(f)) {
					pd=ucitaj(f);
					if(pd==NULL) break;
					dodaj_k(&p,pd);
					}
	return p;
}

void ispis(struct lista *p)
{
		Podnosilac *pd;
		while(p)
		{
				pd=p->podnosilac;
				printf("%s\n",pd->podnosilac);
				printf("%s\n",pd->zirant1);
				printf("%s\n",pd->zirant2);
				p=p->sledeci;
		}
}

void obrisi(struct lista **p, char *s1, char *s2)
{
struct lista *glava,*pom, *el;

glava=*p;
pom=glava;
	while(((strcmp((pom->podnosilac->zirant1),s1)==0) && (strcmp((pom->podnosilac->zirant2),s2)==0)) || ((strcmp((pom->podnosilac->zirant1),s2)==0) && (strcmp((pom->podnosilac->zirant2),s1)==0))) 
	{
		glava=pom->sledeci;
		free(pom);
		pom=glava;
	}
	
	while(pom->sledeci)
		if(((strcmp((pom->sledeci->podnosilac->zirant1),s1)==0) && (strcmp((pom->sledeci->podnosilac->zirant2),s2)==0)) || ((strcmp((pom->sledeci->podnosilac->zirant1),s2)==0) && (strcmp((pom->sledeci->podnosilac->zirant2),s1)==0)))
				{
					el=pom->sledeci;
					pom->sledeci=el->sledeci;
					free(el);
				}
		else pom=pom->sledeci;
*p=glava;
}

/*int pronadji(struct lista *p, char *s3)
{
	struct lista *pom=p;
	char *z1,*z2;
	int br=0;
	while(p){
			if((strcmp(p->podnosilac->podnosilac),s3)==0) break;
			z1=p->podnosilac->zirant1;
			z2=p->podnosilac->zirant2;
			p=p->sledeci;
			}
	while(pom->sledeci)
	if((strcmp((pom->sledeci->podnosilac->zirant1),z1)==0) || (strcmp((pom->sledeci->podnosilac->zirant2),z1)==0) || (strcmp((pom->sledeci->podnosilac->zirant1),z2)==0) || (strcmp((pom->sledeci->podnosilac->zirant2),z1)==0))
	 br++;
	 return br;
	
}*/
main(int argc, char *argv[])
{
struct lista *p;
char s1[100];
char s2[100];
FILE *f;
f=fopen(argv[1],"r");
if(!f) {
		printf("Greska pri otvaranju datoteke.\n");
		exit(0);
		}
p=formiraj(f);
ispis(p);
printf("Unesite ime prvog ziranta.\n");
gets(s1);
printf("Unesite ime drugog ziranta.\n");
gets(s2);
obrisi(&p,s1,s2);
printf("Nakon odbacivanja zahteva lista je:\n");
ispis(p);
}
