#include <stdio.h>
#include <stdlib.h>
#include <string.h>
typedef struct{
	char *ime,*zir1,*zir2;
	}PODNOSILAC;
struct pod{
	PODNOSILAC p;
	struct pod *sledeci;
	};
#define novi(x) x=(struct pod*)malloc(sizeof(struct pod))

void ispravka(char *s){
	int i=0;
	while(s[i]!='\n') i++;
	s[i]='\0';
	}
int dodaj_p(struct pod **P,FILE *f)
{
	struct pod *temp,*pos;
	char c[20];
	fgets(c,20,f);
	ispravka(c);
	if (!strcmp(c,"KRAJ")) return 0;
	else {
		novi(temp);
		if(!temp){
			printf("Neuspesno alociranje\n");
			exit(0);
			}
		temp->sledeci=NULL;
		temp->p.ime=(char*)malloc(strlen(c)+1);
		strcpy(temp->p.ime,c);
		fgets(c,20,f);
		ispravka(c);
		temp->p.zir1=(char*)malloc(strlen(c)+1);
		strcpy(temp->p.zir1,c);
		fgets(c,20,f);		
		ispravka(c);
		temp->p.zir2=(char*)malloc(strlen(c)+1);
		strcpy(temp->p.zir2,c);
		if (!(*P)) (*P)=temp;
		else {
			pos=(*P);
			while(pos->sledeci!=NULL) pos=pos->sledeci;
			pos->sledeci=temp;
			}
		return 1;
		}	
	}
struct pod *lista_p(FILE *f)
{
	struct pod *P=NULL;
	int br=1;
	while(br) {
		br=dodaj_p(&P,f);
	}
	return P;
	}
void ispis_p(struct pod *P)
{
	while(P)
	{
		printf("ime:%s\t 1.zirant:%s \t 2.zirant:%s\n",P->p.ime,P->p.zir1,P->p.zir2);
		P=P->sledeci;
		}
	}
int zajednicki(struct pod *P,char *name)
{
	struct pod *pos,*glavni,*start;	
	int brojac=0;
	start=P;
	pos=P;
	glavni=NULL;
	while (!glavni && pos!=NULL)
	{
		if (!strcmp(pos->p.ime,name)) glavni=pos;
		else pos=pos->sledeci;
		}
	if (!glavni) printf("Ne postoji podnosilac sa zadatim imenom \n");
	else {
		pos=start;
		while (pos!=NULL)
		{
			if (!strcmp(glavni->p.zir1,pos->p.zir1)) {brojac++; pos=pos->sledeci;}
			else if (!strcmp(glavni->p.zir1,pos->p.zir2)) {brojac++; pos=pos->sledeci;}
			else if (!strcmp(glavni->p.zir2,pos->p.zir1)) {brojac++; pos=pos->sledeci;}
			else if (!strcmp(glavni->p.zir2,pos->p.zir2)) {brojac++; pos=pos->sledeci;}
			else pos=pos->sledeci;
			}
		}
	brojac--;
	return brojac;
	}
struct pod *obrisi(struct pod *P, char *zirant1, char *zirant2)
{
	struct pod *pos1,*pos2,*start;
	start=P;
	pos2=NULL;
	pos1=P;
	while (pos1!=NULL){
		if ((!strcmp(pos1->p.zir1,zirant1) && !strcmp(pos1->p.zir2,zirant2)) || (!strcmp(pos1->p.zir1,zirant2) && !strcmp(pos1->p.zir2,zirant1))){
			if (pos2==NULL){
				start=pos1->sledeci;
				free(pos1);
				pos1=start;				
				}
			else {
				pos2->sledeci=pos1->sledeci;
				free(pos1);
				pos1=pos2->sledeci;
				}
			}
		else {
			pos2=pos1;
			pos1=pos1->sledeci;
			}
		}
	return start;
}
main(int argc,char *argv[]){
	struct pod *P;
	char s[20],k[20];
	int o;
	FILE *f=fopen(argv[1],"r");
	if (!f) {
		printf("Neuspesno otvaranje datoteke\n");
		exit(0);
		}
	P=lista_p(f);
	if (!P) {printf("Nema ni jednog podnosioca za ucitati\n"); exit(0);}
	fclose(f);
	ispis_p(P);
	printf("Unesite ime podnosioca zahteva za koje zelite da proverite koliko ima istih ziranata\n");
	gets(s);
	o=zajednicki(P,s);
	if (o>0) printf("Postoji %d podnosilaca koji imaju bar jednog istog ziranta\n",o);
	else if (o==0) printf("Ne postoji ni jedan podnosilac sa bar jednim istim zirantom\n");
	printf("Unesite ime 1. ziranta\n");
	gets(s);
	printf("Unesite ime 2. ziranta\n");
	gets(k);
	P=obrisi(P,s,k);
	if (!P) printf("Nema vise podnosilaca\n");
	else ispis_p(P);	
	}
