#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct Dete
{
	char *imeDeteta;
	char *imeOca;
	char *imeMajke;
	struct Dete *next;
};

char *alociraj_string(int n)
{
	char *p=NULL;
	
	p=(char*)malloc(n*sizeof(char));
	if(p==NULL)
	{
		printf("Greska pri alociranju memorije!\n");
		exit(0);
	}
	
	return (p);
}

void dodaj(struct Dete **glava,struct Dete *temp)
{
	struct Dete *pom=NULL;	
	
	if(*glava==NULL)
	{
		*glava=temp;
		temp->next=NULL;
	}
	else
	{
		pom=*glava;
		
		while(pom->next!=NULL) pom=pom->next;
	
		pom->next=temp;
		temp->next=NULL;
	}
}

struct Dete *formiraj(FILE*f)
{
	struct Dete *glava=NULL;
	char niz[101];
	struct Dete *temp=NULL;

	while(1)
	{
		fgets(niz,100,f);
		if(strcmp(niz,"KRAJ\n")==0) break;
		
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp=(struct Dete *)malloc(sizeof(struct Dete));
		if(temp==NULL)
		{
			printf("Greska pri alociranju memorije!\n");
			exit(0);
		}
		temp->imeDeteta=alociraj_string(strlen(niz)+1);
		strcpy(temp->imeDeteta,niz);
		
		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->imeOca=alociraj_string(strlen(niz)+1);
		strcpy(temp->imeOca,niz);

		fgets(niz,100,f);
		if(niz[strlen(niz)-1]=='\n') niz[strlen(niz)-1]='\0';
		temp->imeMajke=alociraj_string(strlen(niz)+1);
		strcpy(temp->imeMajke,niz);

		dodaj(&glava,temp);
	}
	
	return(glava);
}

void ispis(struct Dete *glava)
{
	struct Dete *pom=NULL;

	pom=glava;

	while(pom!=NULL)
	{
		printf("Ime deteta: %s\n",pom->imeDeteta);
		printf("Ime oca: %s\n",pom->imeOca);
		printf("Ime majke: %s\n",pom->imeMajke);
	
		pom=pom->next;
	}	
}

void odrediti(struct Dete *glava,char niz[])
{
	int ukupno;
	struct Dete *pom1=NULL,*pom2=NULL;
	int i=0;
	
	pom1=glava;

	
	while(pom1!=NULL)
	{
		if(strcmp(niz,pom1->imeDeteta)==0)
		{
			pom2=pom1->next;
			ukupno=0;
			i++;
			while(pom2!=NULL)
			{	
				if((strcmp(pom1->imeOca,pom2->imeOca)==0) || (strcmp(pom1->imeMajke,pom2->imeMajke)==0))
				{
					ukupno++;
					pom2=pom2->next;
				}
				else pom2=pom2->next;
			}
		}
		else pom1=pom1->next;
	}
	
	if(i==0) printf("Nema deteta sa tim imenom u listi!\n");
	else 
	{
		if(ukupno==0) printf("Dete sa imenom %s nema brace/sestara\n",niz);	
		else 
	printf("Dete sa imenom %s ima ukupno %d brace/sestara",niz,ukupno);
	}
}

struct Dete *obrisi(struct Dete *glava,char majka[],char otac[])
{
	if(glava==NULL) printf("Lista je prazna\n");
	else
	{
		while(pom!=NULL)
		{
			if((strcmp(pom->imeOca,otac)==0) && (strcmp(pom->imeMajke,majka)==0))
			{
				if(prethodni==NULL)
				{
					
				}
			}
		}
	}
}


main()
{
	struct Dete *glava=NULL;
	FILE *f=NULL;
	char ime[50];
	char majka[50];
	char otac[50];

	f=fopen("vrtic.txt","r");
	if(f==NULL)
	{
		printf("Greska pri alociranju memorije!\n");
		exit(0);
	}

	glava=formiraj(f);
	ispis(glava);

	printf("\n");
	printf("\n");

	printf("Unesite ime deteta: ");
	fgets(ime,50,stdin);
	if(ime[strlen(ime)-1]=='\n') ime[strlen(ime)-1]='\0';

	odrediti(glava,ime);	

	printf("Unesite ime majke: ");
	fgets(majka,50,stdin);
	if(majka[strlen(majka)-1]=='\n') majka[strlen(majka)-1]='\0';

	printf("Unesite ime oca: ");
	fgets(otac,50,stdin);
	if(otac[strlen(otac)-1]=='\n') otac[strlen(otac)-1]='\0';

	glava=obrisi(glava,majka,otac);

	printf("Azurirana lista: \n");

	ispis(glava);
	
	
}
