#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct podnosilac
{
	char *imep,*imeprvog,*imedrugog;
};

struct lista
{
	struct podnosilac *p;
	struct lista *sledeci;
};

void ucitaj(FILE *f, struct podnosilac **p)
{
	struct podnosilac *pp=*p;
	char s[150]="";
	
	pp=malloc(sizeof(struct lista));
	
	fgets(s,150,f);
	//if (strcmp("KRAJ",s)==0)
	//	{return;*p=pp;}
	pp->imep=malloc(strlen(s)+1);
	strcpy(pp->imep,s);
	
	
	
	fgets(s,150,f);
	pp->imeprvog=malloc(strlen(s)+1);
	strcpy(pp->imeprvog,s);
	
	fgets(s,150,f);
	pp->imedrugog=malloc(strlen(s)+1);
	strcpy(pp->imedrugog,s);
	
	//fgetc(f);
	*p=pp;
}

void dodaj(struct lista **l, struct podnosilac *p)
{
	struct lista *temp,*pom,*tek;
	
	pom=*l;
	
	temp=malloc(sizeof(struct lista));
	temp->p=p;
	temp->sledeci=NULL;
	
	if(!pom)
		pom=temp;
	else
	{
		tek=pom;
		while(tek->sledeci)
			tek=tek->sledeci;
		tek->sledeci=temp;
	}
	
	*l=pom;
}


struct lista *napravi(FILE *f)
{
	struct lista *l=NULL;
	struct podnosilac *p=NULL;
	
	while(1)
	{
		ucitaj(f,&p);
		if(strcmp("KRAJ",p->imep)!=0)
			dodaj(&l,p);
		else
			break;
		if(feof(f))
			break;
	}
	
	return l;
}

void stampa(struct lista *l)
{
	while(l)
	{
		printf("%s\t%s\t%s\n",l->p->imep,l->p->imeprvog,l->p->imedrugog);
		l=l->sledeci;
	}
}

/*int fja(struct lista *l, char ime[])
{
	int i=0;
	struct lista *pom=l;
	while(pom)
	{
		if (strcmp(ime,))
	}
}*/

void brisanje(struct lista **l, char imepz[], char imedz[])
{
	struct lista *temp,*pom,*rez;
	
	temp=pom=rez=*l;
	
	while (((strcmp(pom->p->imeprvog,imepz)==0)&&(strcmp(pom->p->imeprvog,imedz)==0))||((strcmp(pom->p->imedrugog,imepz)==0)&&(strcmp(pom->p->imedrugog,imedz)==0)))
	{
		rez=pom->sledeci;
		free(pom);
		pom=rez;
	}
	
	while(pom->sledeci)
	{
		if (((strcmp(pom->sledeci->p->imeprvog,imepz)==0)&&(strcmp(pom->sledeci->p->imeprvog,imedz)==0))||((strcmp(pom->sledeci->p->imedrugog,imepz)==0)&&(strcmp(pom->sledeci->p->imedrugog,imedz)==0)))
		{
			temp=pom;
			free(temp);
			pom->sledeci=temp;
		}
		else
			pom=pom->sledeci;
	}
	
	*l=rez;
}

main(int argc,char *argv[])
{
	FILE *f=fopen(argv[1],"r");
	char q[50],w[50];
	struct lista *l;
	
	l=napravi(f);
	stampa(l);
	
	printf("Ime 1.\n");
	gets(q);
	printf("Ime 2.\n");
	gets(w);
	
	printf("Posle brisanja:\n");
	brisanje(&l,q,w);
	stampa(l);
	
	fclose(f);
}
